###############################################################################

stages:
  - test
  - package

###############################################################################

variables:
  DOCKER_FILE: Dockerfile

###############################################################################

before_script:
  - test -n "${DOCKER_FILE}"
  - test -f "${DOCKER_FILE}"

###############################################################################

test:
  stage: test
  image:
    name: hadolint/hadolint:v2.12.0-alpine
  variables:
    HADOLINT_CONFIG_FILE: hadolint.yaml
  script:
    - echo "-- Linting Dockerfile --"
    - hash hadolint
    - test -f "${HADOLINT_CONFIG_FILE}"
    - test -f "${HADOLINT_CONFIG_FILE}"
    - hadolint --config "${HADOLINT_CONFIG_FILE}" "${DOCKER_FILE}"

###############################################################################

package:
  stage: package
  only:
    - latest
    - tags
  image: docker:27.1.1-cli
  services:
    - docker:27.1.1-dind
  script:
    - echo "-- Packaging Docker Image --"
    - hash docker
    - test -n "${CI_REGISTRY}"
    - test -n "${CI_REGISTRY_USER}"
    - test -n "${CI_REGISTRY_IMAGE}"
    - test -n "${CI_REGISTRY_PASSWORD}"
    - DOCKER_TAG="${CI_COMMIT_TAG:-latest}"
    - echo "Using Docker image - ${CI_REGISTRY_IMAGE}"
    - echo "Using Docker tag - ${DOCKER_TAG}"
    - docker login --username "${CI_REGISTRY_USER}" --password "${CI_REGISTRY_PASSWORD}" "${CI_REGISTRY}"
    - docker build --file "${DOCKER_FILE}" --tag "${CI_REGISTRY_IMAGE}:${DOCKER_TAG}" "."
    - docker push "${CI_REGISTRY_IMAGE}:${DOCKER_TAG}"
  after_script:
    - docker logout "${CI_REGISTRY}"

###############################################################################
